var loadjsParser = module.exports = {
	REQUIRE_REG: /loadjs.use\(([\s\S]+?)(?=,\s*function|\))|require\((['"][^'"]+['"])/g,
	URL_REG: /['"]([^'"]+)['"]/g,

	SCRIPT_REG: /<script[^>]*>([\s\S]*?)<\/script>/g,

	options: {},

	getPath: function(path){
		var config = this.options.config || {}, baseurl = config.baseurl || '', map = config.map || {};

		(config.rules || []).forEach(function(item){
			path = path.replace(item[0], item[1]);	
		});

		if(baseurl){
			path = baseurl + '/' + path;
		}

		path = path.replace(/\/+/g, '/');

		for(var i in map){
			if(map.hasOwnProperty(i) && inArray(map[i], path)){
				path = i;	
			}	
		}

		return path;
	},

	getDepends: function(files, depends){
		var opt = this.options;

		files.forEach(function(file){
			var cache = opt.parser.getCache(file);

			(cache.get('loadjs_depends') || []).forEach(function(depend){
				if(depends.indexOf(depend) > -1) return;
				depends.push(depend);

				loadjsParser.getDepends([depend], depends);
			});
		});

		return depends;
	},

	htmlParse: function(info, options){
		var opt = loadjsParser.options = options;
		var config = opt.autobuild.util.clone(opt.config || {});

		if(!opt.autobuild.config.watch){
			var scripts = [];

			while(match = loadjsParser.SCRIPT_REG.exec(info.content)){
				scripts = scripts.concat(loadjsParser.parseRequire(match[1]));
			}

			scripts = opt.autobuild.util.unique(scripts);

			var depends = loadjsParser.getDepends(scripts, scripts.slice(0));
			var pkgs = opt.parser.getFinePkg(depends);

			var map = config.map || {};
			var tmp_map = [];

			for(var i in pkgs){
				if(!pkgs[i]) continue;
				tmp_map.push(pkgs[i]);
			}

			opt.autobuild.util.unique(tmp_map).forEach(function(i){
				var tmp_cache = opt.parser.getCache(i);
				var include = tmp_cache.get('include') || [tmp_cache.get('realpath')];
				var tmp = [];

				include.forEach(function(item){
					tmp.push(opt.parser.getCache(item).get('webpath'));
				});

				map[tmp_cache.get('md5webpath')] = tmp;
			});

			config.map = map;
		}

		info.content = info.content.replace(/(<script.*?\bload[\s\S]*?>[\s\S]*?<\/script>)/, function(_0){
			return _0 + '<script>loadjs.config=' + opt.autobuild.util.json(config) + ';</script>';
		});

		return info;
	},

	jsParse: function(info, options){
		loadjsParser.options = options;

		var paths = loadjsParser.parseRequire(info.content);
		info.loadjs_depends = paths;

		return info;
	},

	parseRequire: function(content){
		var opt = loadjsParser.options;

		var scripts = [], tmp;

		while(tmp =	loadjsParser.REQUIRE_REG.exec(content)){
			var t;

			while(t = loadjsParser.URL_REG.exec(tmp[1] || tmp[2])){
				var path = opt.parser.getRealPathByUrl(loadjsParser.getPath(t[1], opt.config));

				if(!opt.autobuild.fs.existsSync(path)) continue;

				scripts.push(path);
			}
		}

		return scripts;
	}
};